// HtmlEditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlEditor.h"
#include "HtmlEditorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHtmlEditorDlg dialog

CHtmlEditorDlg::CHtmlEditorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHtmlEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHtmlEditorDlg)
	m_sAddres = _T("http://www.codeproject.com");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHtmlEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHtmlEditorDlg)
	DDX_Control(pDX, IDC_STATUS, m_ctrlStatus);
	DDX_Control(pDX, IDC_EXPLORER1, m_ctrlWeb);
	DDX_Text(pDX, IDC_ADDRESS, m_sAddres);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHtmlEditorDlg, CDialog)
	//{{AFX_MSG_MAP(CHtmlEditorDlg)
	ON_BN_CLICKED(IDC_GET_HTML, OnGetHtml)
	ON_BN_CLICKED(IDC_BOLD, OnBold)
	ON_BN_CLICKED(IDC_ITALIC, OnItalic)
	ON_BN_CLICKED(IDC_UNDERLINE, OnUnderline)
	ON_BN_CLICKED(IDC_IMAGE, OnImage)
	ON_BN_CLICKED(IDC_HYPERLINK, OnHyperlink)
	ON_BN_CLICKED(IDC_UNDO, OnUndo)
	ON_BN_CLICKED(IDC_REDO, OnRedo)
	ON_BN_CLICKED(IDC_SOURCE, OnSource)
	ON_BN_CLICKED(IDC_TH, OnTh)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_STRIKE, OnStrike)
	ON_BN_CLICKED(IDC_GO, OnGo)
	ON_BN_CLICKED(IDC_EDIT_ON, OnEditOn)
	ON_BN_CLICKED(IDC_EDIT_OFF, OnEditOff)
	ON_BN_CLICKED(IDC_RELOAD, OnReload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHtmlEditorDlg message handlers

BOOL CHtmlEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//let's naviage to TH website - this document will be editable!
	m_ctrlWeb.Navigate( _T("http://www.codeproject.com"), NULL, NULL, NULL,NULL);
	
	//you could call this fuction even now - but Internet Explorer prior to 6.0 want to document to be loaded before enterning designer mode
	//so we will do it in OnNavigateComplete2Explorer1 funtion.
	//m_ctrlWeb.SetDesignMode(TRUE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BEGIN_EVENTSINK_MAP(CHtmlEditorDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CHtmlEditorDlg)
	ON_EVENT(CHtmlEditorDlg, IDC_EXPLORER1, 252 /* NavigateComplete2 */, OnNavigateComplete2Explorer1, VTS_DISPATCH VTS_PVARIANT)
	ON_EVENT(CHtmlEditorDlg, IDC_EXPLORER1, 102 /* StatusTextChange */, OnStatusTextChangeExplorer1, VTS_BSTR)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CHtmlEditorDlg::OnNavigateComplete2Explorer1(LPDISPATCH pDisp, VARIANT FAR* URL) 
{
	//let's turn on HTML editing capabilities!
	m_ctrlWeb.SetDesignMode(TRUE);
	
	SetWindowText( "Current URL: " + m_ctrlWeb.GetLocationURL() );
} 

void CHtmlEditorDlg::OnGetHtml() 
{
	CString str;
	m_ctrlWeb.GetDocumentHTML(str);
	AfxMessageBox(str);
}

void CHtmlEditorDlg::OnBold() 
{
	m_ctrlWeb.Bold();
}

void CHtmlEditorDlg::OnItalic() 
{
	m_ctrlWeb.Italic();
}

void CHtmlEditorDlg::OnUnderline() 
{
	m_ctrlWeb.Underline();	
}

void CHtmlEditorDlg::OnImage() 
{
	m_ctrlWeb.Image();	
}

void CHtmlEditorDlg::OnHyperlink() 
{
	m_ctrlWeb.HyperLink();	
}

void CHtmlEditorDlg::OnUndo() 
{
	m_ctrlWeb.Undo();	
}

void CHtmlEditorDlg::OnRedo() 
{
	m_ctrlWeb.Redo();	
}

void CHtmlEditorDlg::OnSource() 
{
	m_ctrlWeb.ShowSource();	
}

void CHtmlEditorDlg::OnTh() 
{
	ShellExecute(NULL, _T("open"), _T("http://www.trayhelper.com/indexeng.html"), NULL,NULL,SW_SHOW);
}

void CHtmlEditorDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if(m_ctrlWeb.m_hWnd)
	{
		m_ctrlWeb.SetWidth(cx);
		m_ctrlWeb.SetHeight(cy - 80);
	}
}

void CHtmlEditorDlg::OnStrike() 
{
	m_ctrlWeb.StrikeOut();	
}

void CHtmlEditorDlg::OnGo() 
{
	UpdateData();
	m_ctrlWeb.Navigate(m_sAddres,NULL, NULL,NULL,NULL);
}

void CHtmlEditorDlg::OnEditOn() 
{
	if(m_ctrlWeb.IsDesignMode() == TRUE)
	{
		AfxMessageBox(_T("Design mode is already ON!"));
	}
	else
	{
		m_ctrlWeb.SetDesignMode(TRUE);
	}
}

void CHtmlEditorDlg::OnEditOff() 
{
	if(m_ctrlWeb.IsDesignMode() == FALSE)
	{
		AfxMessageBox(_T("Design mode is already OFF!"));
	}
	else
	{
		m_ctrlWeb.SetDesignMode(FALSE);
	}
}

void CHtmlEditorDlg::OnStatusTextChangeExplorer1(LPCTSTR Text) 
{
	m_ctrlStatus.SetWindowText(Text);
}

void CHtmlEditorDlg::OnReload() 
{
	m_ctrlWeb.Refresh();	
}
